package ovh.herisson.Clyde.Tables;

import jakarta.persistence.*;
import lombok.Data;
import ovh.herisson.Clyde.Tables.Msg.Discussion;
import ovh.herisson.Clyde.Tables.Msg.Message;

import java.util.Date;
import java.util.List;


@Entity
@Table(name = "Users")
@Data
public class User {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long regNo;
    private String lastName;
    private String firstName;
    @Column(unique = true)
    private String email;
    private String address;
    private String country;
    private Date birthDate;
    private String profilePictureUrl;
    private ovh.herisson.Clyde.Tables.Role role;
    private String password;

	@OneToMany(mappedBy = "user")
	private List<Notification> notifications; 

	////// Extension Messagerie /////
	@OneToMany(mappedBy = "author", cascade = CascadeType.ALL)
	private List<Message> msgs;
	/////////////////////////////////

	@ManyToMany( mappedBy = "members" )
	private List<Discussion> discussions;

    public User(String lastName, String firstName, String email, String address,
                String country, Date birthDate, String profilePictureUrl, Role role, String password)
    {
        this.lastName = lastName;
        this.firstName = firstName;
        this.email = email;
        this.address = address;
        this.country = country;
        this.birthDate = birthDate;
        this.profilePictureUrl = profilePictureUrl;
        this.role = role;
        this.password = password;
    }

    public User(String lastName, String firstName, String email, String address,
                String country, Date birthDate, String profilePictureUrl, String password)
    {
        this.lastName = lastName;
        this.firstName = firstName;
        this.email = email;
        this.address = address;
        this.country = country;
        this.birthDate = birthDate;
        this.profilePictureUrl = profilePictureUrl;
        this.password = password;
        this.role = Role.Student;
    }
}
